{% extends "operators/base.html" %}{% load i18n static %}
{% block title %}
    {% if problematic %}{% trans "Fixing" %} {{ form.address.value }}
    {% elif form.name.value %}{% trans "Editing" %} "{{ form.name.value }}"
    {% else %}{% trans "Add location" %}{% endif %}
{% endblock %}
{% block extrahead %}
<link rel="stylesheet" href="{% static 'leaflet1/leaflet.css' %}" />
<script src="{% static 'leaflet1/leaflet.js' %}"></script>
<link href="{% static 'select2/css/select2.min.css' %}" rel="stylesheet" />
<script src="{% static 'select2/js/select2.min.js' %}"></script>
{% endblock %}
{% block content %}

<div class="page-header mb-4">
    <h1>
        {% if problematic %}{% trans "Fixing" %} {{ form.address.value }}
        {% elif form.name.value %}{% trans "Editing" %} "{{ form.name.value }}"
        {% else %}{% trans "Add location" %}{% endif %}
    </h1>
</div>

<div class="row">
    <div class="col-lg-4">
        {{ form.errors }}
        <form action="" method="post">
            {% csrf_token %}
            <div class="form-group mb-3">
                {{ form.name.label }}:
                {{ form.name }}
            </div>
            <div class="form-group mb-3">
                <label for="id_address">{% trans "Address" %}:</label>
                <select name="address" id="id_address" class="form-control">
                    {% if form.address.value %}<option value="{{ form.address.value }}" selected>{{ form.address.value }}</option>{% endif %}
                </select>
            </div>
            <div class="row">
                <div class="col-lg-6">
                    {{ form.lat }}
                </div>
                <div class="col-lg-6">
                    {{ form.lng }}
                </div>
            </div>
            <div class="mt-4 text-end">
                <button role="button" type="submit" class="btn btn-lg btn-success">
                    <i class="fas fa-save"></i> &nbsp; {% trans "Save" %}
                </button>
            </div>
        </form>
    </div>
    <div class="col-lg-8">
        <div id="map" style="height: 600px;"></div>
    </div>
</div>

<script type="text/javascript">
    $(document).ready(function() {
        // map configuration
        window.map = L.map('map').setView([46.497523, 11.352499], 13);
        window.layergroup = L.layerGroup().addTo(window.map);
        var tiles = L.tileLayer('//{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
            maxZoom: 18,
            minZoom: 2,
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(window.map);
        {% if form.address.value and form.lat.value and form.lng.value %}
            L.marker([{{ form.lat.value|safe }}, {{ form.lng.value|safe }}]).addTo(window.layergroup);
            window.map.setView([{{ form.lat.value|safe }}, {{ form.lng.value|safe }}], 15);
        {% endif %}

        // address search via OSM Nominatim
        $('#id_address').select2({
            ajax: {
                url: "{% url 'addresses-ajax-search' %}",
                dataType: "json",
                delay: 400,
                type: "POST",
                data: function (params) {return {"q": params.term, "csrfmiddlewaretoken": "{{ csrf_token }}"};},
                processResults: function (data, params) {return {results: data}}
            },
            placeholder: "{% trans 'Start typing the address' %}",
            minimumInputLength: 6,
            templateResult: function (address) {return address.display_name || "{% trans 'Searching...' %}";}
        }).on("select2:select", function (e) {
            window.address = e.params.data;
            window.layergroup.clearLayers();
            L.marker([window.address.lat, window.address.lon]).addTo(window.layergroup);
            window.map.setView([window.address.lat, window.address.lon]);
            $("#id_lat").val(window.address.lat);
            $("#id_lng").val(window.address.lon);
        });
    });
</script>

{% endblock %}